con

  _clkmode = xtal1+pll16x
  _clkfreq = 114_285_714

  _SD_DO = 20
  _SD_CLK = 21
  _SD_DI = 22
  _SD_CS = 23
  _SD_WP = -1 ' -1 ifnot installed.
  _SD_CD = -1 ' -1 ifnot installed.



obj
  vga           : "vnfg092"
  fat           : "kyefat_lfn"
  i2c           : "i2cdrv"
  sid           : "SIDcog44-0.95"     


var

byte buffer2[25]
long buffer3[512]   
  
pub boot   |i  ,j ,k,l  ,  c,w,s  ,wait ,q  ,ss   ,qq    ,xx,yy,xxd,yyd


vga.start   


i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$0)
i2c.stop(18)


i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$1)
i2c.write(18,$1f)
i2c.stop(18)


i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$8)
i2c.write(18,$12)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0a)
i2c.write(18,$0)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0c)
i2c.write(18,$62)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$0e)
i2c.write(18,$1b)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$10)
i2c.write(18,$22)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$6)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$4)
i2c.write(18,$78)
i2c.stop(18)

i2c.start(18)
i2c.write(18,$34)
i2c.write(18,$12)
i2c.write(18,$1)
i2c.stop(18)



vga.poke($8F000,96)                 ' set 1920x1080
vga.poke($8F001,159) 
vga.poke($8F002,1953) 
vga.poke($8F003,2016) 
vga.poke($8F004,2160) 
vga.poke($8F005,2256) 
vga.poke($8F006,25)  
vga.poke($8F007,65) 
vga.poke($8F008,1065) 
vga.poke($8F009,1105)  
vga.poke($8F00a,1120) 
vga.poke($8F00b,1125) 
vga.poke($8F00c,3) ' 2 lower bits -> h/v sync polarity.
  
repeat i from $83000 to $83023     ' clear display and audio registers
  vga.poke(i,0)
repeat i from $84000 to $84100     ' clear audio buffer
  vga.poke(i,0) 
repeat i from $70000 to $71000     ' clear DL area
  vga.poke(i,0) 

vga.poke($83000+36,0)              ' switch off leds and hex
vga.poke($83000+37,$FFFFFFFF)
vga.poke($83000+38,$FFFFFFFF)
vga.poke($83003,255)

vga.poke($70020,%11_0000_0000_0000_00_0000_0000_0000_0000)
vga.poke($70280,%11_0000_0010_0000_00_0000_0000_0000_0000)
vga.poke($83006,$80070000)         'DL on     
 
vga.poke ($83009,$80008000+2000)    'move sprites away 
vga.poke ($8300a,$80008000+2000)
vga.poke ($8300b,$80008000+2000)
vga.poke ($8300c,$80008000+2000)
vga.poke ($8300d,$80008000+2000)     
vga.poke ($8300e,$80008000+2000)


vga.graphics(10)   ' prepare the sprites
vga.cls
vga.outtextxy(0,8,string("SIDCog-44k1 demo"),232) 
repeat i from 1 to 7
  vga.line(0,i-1,200,i-1,i*16+8)
repeat i from 8 to 15
  vga.line(0,i+16,200,i+16,i*16+8)       
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82000+j+8*i,vga.peek(j+112*i))
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82100+j+8*i,vga.peek(8+j+112*i))
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82200+j+8*i,vga.peek(16+j+112*i))
repeat i from 0 to 31
  repeat j from 0 to 7
    vga.poke($82300+j+8*i,vga.peek(24+j+112*i))
    
vga.poke($83009,$027803c0)    
vga.poke($8300a,$027803e0)    
vga.poke($8300b,$02780400)    
vga.poke($8300c,$02780420)
 
vga.graphics(0)
vga.setataripallette(0)   
vga.cls
vga.poke($83000+37,$0)      'hex on
vga.poke($83005,$80100400)  'horizontal pallette switch on 
vga.line(500,0,500,999,1)
vga.line(652,0,652,999,1)
vga.box(501,0,651,999,2)
vga.line(1500,0,1500,999,1)
vga.line(1652,0,1652,999,1)
vga.box(1501,0,1651,1000,2)
vga.setcolor(1,255,255,255)
vga.setcolor(2,0,128,0)
vga.setcolor(3,0,255,255)
vga.setcolor(6,128,0,0)
vga.setcolor(5,255,255,0)
vga.setcolor(4,64,32,0)
vga.setcolor(7,128,0,255) 
vga.setcolor(10,0,64,128)
vga.setcolor(9,0,255,255)
vga.setcolor(8,0,32,64)
vga.setcolor(11,0,0,255) 
vga.setcolor(14,64,64,0)
vga.setcolor(13,255,128,64)
vga.setcolor(12,128,64,0)
vga.setcolor(15,255,128,0) 
vga.outtextxy(512,60,string("SIDCog 44k1 demo"),3)   
vga.outtextxy(1512,60,string("SIDCog 44k1 demo"),3)   
i:=66
j:=159

sid.start
fat.FATEngineStart(_SD_DO, _SD_CLK, _SD_DI, _SD_CS, _SD_WP, _SD_CD, -1, -1, -1)
vga.poke ($83000+37,$FFFFFF00)
i:=fat.mountpartition(0)

vga.poke ($83000+37,$FFFF0000) 
xxd:=1
yyd:=1
xx:=100
yy:=100

vga.poke ($83000+37,$FFFFFFFF)

vga.poke ($83010,0)
vga.poke ($83011,0)
vga.poke ($83012,0)
vga.poke ($83013,0)
vga.poke ($8302a,0)
vga.poke ($83003,$FFFFFF)

   
repeat i from $84000 to $843ff
  vga.poke(i,0)  
vga.setirq(64)
vga.poke($83000+38,%11111111_11111111_11111111_11111111)    

 
repeat
 
  fat.openfile(string("013.dmp"),"R") 
  s:=sid.getsidsample
  vga.audiocmd (s)
  wait:=cnt+clkfreq/50
  repeat
    ss:=vga.peek($83000+39)&7
    if ss==0
      qq:=50
      vga.poke($83000+37,%11111111_11111111_10010010_11000000)
    if ss==1
      qq:=100
      vga.poke($83000+37,%11111111_11111001_11000000_11000000)     
    if ss==2
      qq:=150
      vga.poke($83000+37,%11111111_11111001_10010010_11000000)     
    if ss==4
      qq:=200
      vga.poke($83000+37,%11111111_10100100_11000000_11000000)   
    w:=clkfreq/qq
    xx:=xx+xxd
    yy:=yy+yyd
    if (xx>1900)
       xxd:=-1
    if (xx<170)
      xxd:=1
    if (yy<65)
      yyd:=1
    if (yy>1150)
      yyd:=-1
    vga.poke($83009,$40004000+xx+(yy<<16))    
    vga.poke($8300a,$40004000+64+xx+(yy<<16))    
    vga.poke($8300b,$40004000+128+xx+(yy<<16))  
    vga.poke($8300c,$40004000+192+xx+(yy<<16))
    c:=fat.readdata(@buffer2,25)    
    waitcnt(wait)  
    wait:=wait+w
    sid.updateRegisters(@buffer2)
  until (c<>25)
  fat.closefile
  bytefill(@buffer2,0,25)
  sid.updateRegisters(@buffer2)


